#ifndef __BuddhaBoundingFrustum_H__
#define __BuddhaBoundingFrustum_H__

#include "BuddhaMatrix.h"
#include "BuddhaPlane.h"
#include "BuddhaVector3.h"

namespace BuddhaXNA
{
	/// tX^\Ă\
	struct BoundingFrustum
	{
	public:
		Plane Near;
		Plane Far;

		Plane Top;
		Plane Right;
		Plane Bottom;
		Plane Left;

		/**
		 * @internal
		 */
		BoundingFrustum(void);

		/**
		 * @brief RXgN^
		 * @param value r[~vWFNV
		 */
		BoundingFrustum(const Matrix &value);

	public:
		/**
		 * @brief	̐䂪 \e position Ŏw肳W܂ł邩ǂ`FbN
		 * @param	position	`FbNW
		 * @return	̒ \e position Ă true Ԃ
		 */
		bool Contains(const Vector3 &position) const;

	protected:
		/**
		 * @internal
		 */
		inline void _normalizePlane(Plane &plane)
		{
			plane.Normal.Normalize();
			FLOAT length = plane.Normal.Distance();
			plane.D /= length;
		}
	};
}

#endif
