#ifndef __BuddhaFont_H__
#define __BuddhaFont_H__

#include <d3dx9.h>
#include "BuddhaSharedPtr.h"

namespace BuddhaXNA
{
	class GraphicsDevice;
	class SpriteBatch;

	/// GDIgptHgNX
	class BuddhaFont
	{
		friend SpriteBatch;

	protected:
		LPD3DXFONT m_pDXFont;
		int mSize;

	public:
		/**
		 * @brief RXgN^
		 * @public device OtBbNfoCX
		 * @public fontFace tHg
		 * @public size tHgTCY
		 */
		BuddhaFont(GraphicsDevice *device, LPCWSTR fontFace, int size);
		virtual ~BuddhaFont();

		/**
		 * @internal
		 */
		LPD3DXFONT _getD3D9Font(void)
		{
			return m_pDXFont;
		}

		/**
		 * @internal
		 */
		int _getSize()
		{
			return mSize;
		}
	};

	/// BuddhaFont NXp̋L|C^NX
	class BuddhaFontPtr : public SharedPtr<BuddhaFont>
	{
	public:
		BuddhaFontPtr() : SharedPtr<BuddhaFont>() {}
		explicit BuddhaFontPtr(BuddhaFont* rep) : SharedPtr<BuddhaFont>(rep) {}
		BuddhaFontPtr(const BuddhaFontPtr &r) : SharedPtr<BuddhaFont>(r) {}
	protected:
		void destory(void)
		{
			SharedPtr<BuddhaFont>::destroy();
		}
	};
}


#endif