#ifndef __BuddhaGame_H__
#define __BuddhaGame_H__

#include <d3d9.h>
#include <list>
#include <dinput.h>

#include "BuddhaGameTime.h"
#include "BuddhaGameComponent.h"
#include "BuddhaGameServiceContainer.h"
#include "BuddhaGameWindow.h"

namespace BuddhaXNA
{
	class GameComponentCollection;
	class GraphicsDeviceManager;

	/// {IȃOtBbNfoCX̏AQ[WbNA_OR[h񋟂
	class Game
	{
		friend GraphicsDeviceManager;

	private:
		static Game *_mInstance;

		GameTime mGameTime;
		LPDIRECTINPUT8 m_pInput;

		DWORD mGameStartTime;	///< Q[NJn
		DWORD mLastUpdateTime;	///< Ō Update ̋L^
		bool mIsStoreLastTime;	///< mLastUpdateTime L^ǂ

		bool mIsFixedTimeStep;	///< ŒXVǂ
		DWORD mTargetElapsedTime;	///< XVԊu

		GraphicsDeviceManager *m_pGraphicDeviceManagerInterface;

		bool mIsActive;	///< AvP[VANeBuǂ

		friend GraphicsDeviceManager;

		/// ֘AtꂽIy[VVXẽEBhE
		GameWindow* m_pGameWindow;	

	protected:
		/// R|[lgRNVւ̃|C^
		GameComponentCollection* m_pComponents;

		/**
		 * @iternal
		 */
		GameServiceContainer* m_pServices;

		virtual HRESULT initD3D();
		virtual HRESULT initInput();

		/**
		 * @internal
		 * @brief Windows OS ̃ZbgAbvs
		 */
		virtual void initializeForWindows(void);

		/**
		 * @brief Q[̏s
		 * @attention
		 *      ̎_ł̓OtBbNfoCX͏ĂȂ߁Aӂ邱
		 */
		virtual void Initialize(void) = 0;

	public:
		/// RXgN^
		Game(void);

		/// fXgN^
		virtual ~Game();

		/**
		 * @internal
		 */
		static Game* _getInstance(void)
		{
			return _mInstance;
		}

		/**
		 * @internal
		 */
		LPDIRECTINPUT8 _getDirectInput8()
		{
			return m_pInput;
		}

		void Run(void);
		void _Update(void);
		void _Draw(void);

		/// Q[WbN̏KvȂƂɌĂяoBI[o[ChāAQ[EWbNB
		virtual void Update(GameTime gameTime) = 0;

		/// Pt[̕`悪KvȂƂɌĂяoBI[o[ChāA_OR[hB
		virtual void Draw(GameTime gameTime) = 0;

		/**
		 * @brief Q[OtBbNRec[h
		 * @remarks
		 *     ̃o֐́AKvɉĊNXĂт܂B
		 *
		 *     \li Game::Update() ̃[vJnOɁA loadAllContent = true ŁÃo֐
		 *         Ăт܂B̍ہAR|[lgRNVɃRNV΁AɃRN
		 *         V DrawableGameComponent::LoadGraphicContent() Ăт܂B
		 *     \li foCX̏ȂǂɂAxOtBbNRecŊmۂȂ΂ȂȂȂ
		 *         ꍇAloadAllContent = false ł̊֐Ăт܂B̏ꍇAɃR|[l
		 *         g̃[hsAŌ Game NX̃A[hĂт܂B
		 *
		 * @param loadAllContent true ̂ƂAǗ̃OtBbNRec[h
		 */
		virtual void LoadGraphicContent(bool loadAllContent) {}

		/**
		 * @brief Q[ĂOtBbNRec
		 * @remarks
		 *     ̃o֐́AKvɉĊNXĂт܂B
		 *
		 *     \li foCX̏ȂǂɂAxOtBbNRecȂ΂ȂȂꍇA
		 *         unloadAllContent = false ł̊֐Ăт܂B̏ꍇAɃR|[lg
		 *         RNṼA[hsAŌ Game NX̃A[hĂт܂B
		 *     \li AvP[VIۂɁA unloadAllContent = true ł̊֐Ăт܂B
		 *         ̏ꍇAR|[lgRNṼA[h͌Ăт܂B
		 *
		 * @param unloadAllContent true ̂ƂAǗ̃OtBbNRec
		 */
		virtual void UnloadGraphicContent(bool unloadAllContent) {}

		virtual void Cleanup(void) {}

		/// R|[lgRNV擾
		GameComponentCollection* GetComponents(void)
		{
			return m_pComponents;
		}

		/// ̃Q[݂̃ANeBuAvP[Vǂ
		bool IsActive(void)
		{
			return mIsActive;
		}

		/**
		 * @internal
		 * @brief IsActive ̒lZbg
		 * @attention
		 *     pr
		 */
		void _isActive(bool isActive)
		{
			mIsActive = isActive;
		}

		/**
		 * @iternal
		 */
		GameServiceContainer* GetServices(void)
		{
			return m_pServices;
		}

		/**
		 * @brief {IȃIy[VVXẽEBhE擾
		 */
		GameWindow* GetWindow(void) const
		{
			return m_pGameWindow;
		}

	protected:
		virtual bool BeginDraw(void);
		virtual void EndDraw(void);
	};
}

#endif