#ifndef __BuddhaGameTime_H__
#define __BuddhaGameTime_H__

namespace BuddhaXNA
{
	class Game;

	/// ԊԊuiQ̎̍j\\
	struct TimeSpan
	{
	protected:
		long mTicks;

	public:
		/// v~b
		double TotalMilliseconds;
		double TotalSeconds;

		/// Pʂ̎ԊԊu
		double TotalMinutes;

		double TotalHours;
		double TotalDays;


		TimeSpan()
		{
			TotalMilliseconds = 0;
			TotalSeconds = 0;
			TotalMinutes = 0;
		}

		TimeSpan(DWORD msec)
		{
			TotalMilliseconds = msec;
			TotalSeconds = msec / 1000.0f;
			TotalMinutes = TotalSeconds / 60.0f;
		}

		/**
		 * @brief V TimeSpan w肵^C}݂̐ɏ
		 */
		TimeSpan(long ticks)
			: mTicks(ticks)
		{
			TotalMilliseconds = mTicks;
			TotalSeconds = mTicks / 1000.0f;
			TotalMinutes = TotalSeconds / 60.f;
			TotalHours = TotalMinutes / 60.0f;
			TotalDays = TotalHours / 24.0f;
		}

		/**
		 * @brief ԊԊuPʂŎ擾B
		 * @remarks
		 *     ) 25.5͂QTƂPQԂ\
		 */
		double GetTotalDays(void) const
		{
			return TotalDays;
		}

		/**
		 * @brief ԊԊuԒPʂŎ擾B
		 * @remarks
		 *     ) 25.5͂PƂPԂRO\
		 */
		double GetTotalHours(void) const
		{
			return TotalHours;
		}

		/**
		 * @brief ԊԊu𕪒PʂŎ擾B
		 * @remarks
		 *     ) 123.5͂QԂRROb\
		 */
		double GetTotalMinutes(void) const
		{
			return TotalMinutes;
		}

		/**
		 * @brief ԊԊubPʂŎ擾
		 * @remarks
		 *     ) 123.5͂QR.Tb\
		 *     
		 */
		double GetTotalSeconds(void) const
		{
			return TotalSeconds;
		}

		/**
		 * @brief ԊԊu~bPʂŎ擾
		 * @remarks
		 *     12300  12.3 b\
		 */
		double GetTotalMilliseconds(void) const
		{
			return TotalMilliseconds;
		}

		/**
		 * @brief ݂ TimeSpan \̂\[ȂŎ擾܂B 
		 * @todo LbVɏĈ
		 */
		int GetDays(void) const
		{
			return static_cast<int>(GetTotalDays());
		}

		/**
		 * @brief ݂ TimeSpan \̂\Ԑ[ȂŎ擾܂B
		 * @todo LbVɏĈ
		 */
		int GetHours(void) const
		{
			double value = TotalHours - (int)GetTotalDays() * 24;
			return static_cast<int>(value);
		}

		/**
		 * @brief ݂ TimeSpan \̂\[ȂŎ擾܂B
		 * @todo LbVɏĈ
		 */
		int GetMinutes(void) const
		{
			double value = TotalMinutes - (int)GetTotalHours() * 60;
			return static_cast<int>(value);
		}

		/**
		 * @brief ݂ TimeSpan \̂\Ԑ[ȂŎ擾܂B
		 * @todo LbVɏĈ
		 */
		int GetSeconds(void) const
		{
			double value = TotalSeconds - (int)GetTotalMinutes() * 60;
			return static_cast<int>(value);
		}

		/**
		 * @brief ݂ TimeSpan \̂\Ԑ[ȂŎ擾
		 * @remarks
		 *     ԊԊu̕b̒[̒l𐮐lŕԂ
		 * @todo LbVɏĈ
		 */
		int GetMilliseconds(void) const
		{
			double value = TotalMilliseconds - (int)GetTotalMilliseconds() * 1000;
			return static_cast<int>(value);
		}

		/**
		 * @brief ݂ TimeSpan \̂\^C}݂̐擾
		 */
		long GetTicks(void) const
		{
			return mTicks;
		}
	};

	/// Q[킷\
	struct GameTime
	{
		friend Game;

	private:
		bool mIsRunningSlowly;

	public:
		/**
		 * @brief Q[X^[gĂ̎ԁiǎvǰoߎԊԊu
		 */
		TimeSpan TotalRealTime;

		/**
		 * @brief Ō̃t[̎ԁiǎvǰoߎԊԊu
		 */
		TimeSpan ElapsedRealTime;

		/**
		 * @brief Q[X^[gĂ̌oߎԊԊu
		 */
		TimeSpan TotalGameTime;

		/**
		 * @brief Ō̃Abvf[ǧoߎԊԊu
		 */
		TimeSpan ElapsedGameTime;

		/// RXgN^
		GameTime()
			: mIsRunningSlowly(false)
		{
		}

		/// RXgN^
		GameTime(TimeSpan &totalRealTime, TimeSpan &elapsedRealTime, TimeSpan &totalGameTime, TimeSpan &elapsedGameTime)
			: TotalRealTime(totalRealTime),
			  ElapsedRealTime(elapsedRealTime),
			  TotalGameTime(totalGameTime),
			  ElapsedGameTime(elapsedGameTime),
			  mIsRunningSlowly(false)
		{
		}

		/// RXgN^
		GameTime(TimeSpan &totalRealTime, TimeSpan &elapsedRealTime,
			TimeSpan &totalGameTime, TimeSpan &elapsedGameTime, bool isRunningSlowly)
			: TotalRealTime(totalRealTime),
			  ElapsedRealTime(elapsedRealTime),
			  TotalGameTime(totalGameTime),
			  ElapsedGameTime(elapsedGameTime),
			  mIsRunningSlowly(isRunningSlowly)
		{
		}

		/**
		 * @brief Q[[v TargetElapsedTime 莞ԂĂ邩ǂl擾
		 * @return l^̏ꍇA鏈Ă
		 *
		 * l^̏ꍇAQ[[v͏ԂɂƍlBɒǂt߂ɉ
		 * Ȃ΂ȂȂB
		 */
		bool IsRunningSlowly()
		{
			return mIsRunningSlowly;
		}
	};
}

#endif