#ifndef __BuddhaIndexBuffer_H__
#define __BuddhaIndexBuffer_H__

#include <d3d9.h>
#include "BuddhaSharedPtr.h"

namespace BuddhaXNA
{
	class GraphicsDevice;

	/// _obt@ɂA_̃_OLq܂
	class IndexBuffer
	{
		friend GraphicsDevice;

	private:
		LPDIRECT3DINDEXBUFFER9 m_pIndexBuffer;

	public:
		/**
		 * @brief RXgN^
		 * @remarks
		 *     RXgN^ɂāACfbNXobt@mۂ܂B
		 *     ɖ肪Ȃ IndexBufferPtr Ɋi[ĎgpĂB
		 */
		IndexBuffer(GraphicsDevice* device, int sizeInBytes, DWORD usage, D3DPOOL resourceManagementMode, D3DFORMAT elementSize);

		/**
		 * @brief fXgN^
		 * @attention
		 *     CfbNXobt@J܂B
		 */
		virtual ~IndexBuffer();

		/**
		 * @brief f[^zCfbNXobt@ɃRs[܂
		 * @remarks
		 *     CfbNXobt@̃bNEAbN͓ŎIɍs܂
		 * @param src f[^z̐擪AhX
		 * @param length f[^̒ij
		 */
		void SetData(short *src, int length);
	};

	/**
	 * @brief CfbNXGgTCY񋓂ĂNX
	 * @remarks
	 *     ̃NX́A C# X^C enum lw񋟂邽߂ɑ݂ĂAXNA o҂ C++ ł
	 *     l̃X^CŃGgTCYw肷邱ƂłB
	 */
	class IndexElementSize
	{
	public:
		static const D3DFORMAT SixteenBits;
		static const D3DFORMAT ThirtyTwoBits;
	};


	/// IndexBuffer NXp̔틤L|C^NX
	class IndexBufferPtr : public SharedPtr<IndexBuffer>
	{
	public:
		IndexBufferPtr() : SharedPtr<IndexBuffer>() {}
		explicit IndexBufferPtr(IndexBuffer* rep) : SharedPtr<IndexBuffer>(rep) {}
		IndexBufferPtr(const IndexBufferPtr &r) : SharedPtr<IndexBuffer>(r) {}
	protected:
		void destory(void)
		{
			SharedPtr<IndexBuffer>::destroy();
		}
	};
}

#endif