#ifndef __BuddhaSpriteBatch_H__
#define __BuddhaSpriteBatch_H__

#include <d3dx9.h>
#include "BuddhaTexture2D.h"
#include "BuddhaFont.h"
#include "BuddhaColor.h"

namespace BuddhaXNA
{
	class GraphicsDevice;
	struct Vector2;

	enum Buddha_SpriteBlendMode
	{
		ADDITIVE,
		ALPHABLEND,
		NONE
	};

	/**
	 * @brief uh[h񋓂ĂNX
	 * @remarks
	 *     ̃NX́A C# X^C enum lw񋟂邽߂ɑ݂ĂAXNA o҂ C++ ł
	 *     l̃X^CŃuh[hw肷邱ƂłB
	 */
	class SpriteBlendMode
	{
	public:
		static const Buddha_SpriteBlendMode Additive = ADDITIVE; 
		static const Buddha_SpriteBlendMode AlphaBlend = ALPHABLEND; 
		static const Buddha_SpriteBlendMode None = NONE; 
	};

	/// ZbeBOgpăXvCg̃O[v`悷邱Ƃ\ɂNX
	class SpriteBatch
	{
	protected:
		GraphicsDevice* m_pDevice;
		LPD3DXSPRITE m_pSprite;

	public:
		SpriteBatch(GraphicsDevice* device);
		~SpriteBatch();

		/// XvCg̕`s悤OtBbNfoCX
		void Begin(void);

		/**
		 * @brief w肵uh[hw肵ăXvCg̕`s悤OtBbNfoCX
		 * @param blendMode uh[hBSpriteBlendMode NX̒lŎw肷邱Ƃł
		 */
		void Begin(Buddha_SpriteBlendMode blendMode);

		/// XvCgob`tbVAfoCX̏Ԃ Begin() ĂԑȌԂɖ߂
		void End(void);

		/// w肵eNX`wXN[WƐFŃXvCgob`ɒǉ
		void Draw(const Texture2DPtr &texture, const Vector2 &position, const Color &color);

		void Draw(const Texture2DPtr &texture, const Rectangle &rect, const Color &color);

		/**
		 * @internal
		 */
		void Draw(const Texture2DPtr &texture, const RECT &rect, const Color &color);

		/**
		 * @brief XvCgob`Ɏw肵tHgAo̓eLXgAʍWAFŕǉ
		 * @param font tHg
		 * @param text `悷镶
		 * @param position text `悷XN[W
		 * @param color `F
		 * @param size TCY
		 */
		void DrawString(const BuddhaFontPtr &font, LPCWSTR text , const Vector2 &position, const Color &color);

		/**
		 * @brief XvCgob`Ɏw肵tHgAo̓eLXgAʍWAFŕǉ
		 * @param font tHg
		 * @param text `悷镶
		 * @param position text `悷XN[W
		 * @param color `F
		 * @param size TCY
		 */
		void DrawString(const BuddhaFontPtr &font, const String &text, const Vector2 &position, const Color &color)
		{
			DrawString(font, text.c_str(), position, color);
		}
	};

	/// SpriteBatch NXp̔틤L|C^NX
	class SpriteBatchPtr : public SharedPtr<SpriteBatch>
	{
	public:
		SpriteBatchPtr() : SharedPtr<SpriteBatch>() {}
		explicit SpriteBatchPtr(SpriteBatch* rep) : SharedPtr<SpriteBatch>(rep) {}
		SpriteBatchPtr(const SpriteBatchPtr &r) : SharedPtr<SpriteBatch>(r) {}
	protected:
		void destory(void)
		{
			SharedPtr<SpriteBatch>::destroy();
		}
	};
}


#endif
