#include "BuddhaBasicEffect.h"
#include "BuddhaGraphicsDevice.h"
#include "BuddhaGpuEffectTechnique.h"

using namespace BuddhaXNA;

BasicEffect::BasicEffect(GraphicsDevice* device)
	: GpuEffect(device)
{
	HRESULT hr = D3DXCreateEffectFromFile(device->_getD3D9Device(), L"BasicEffect.fx", NULL, NULL, 0, NULL, &m_pEffect, NULL);

	if (FAILED(hr)) {
		// TODO Exception
	}

	// ZbgAbv
	// ܂ől
	unsigned int numTechniques;
	for (numTechniques = 0; m_pEffect->GetTechnique(numTechniques) != NULL ; numTechniques++);

	mTechniqueList.resize(numTechniques);

	for (unsigned int i = 0; i < numTechniques; i++)
	{
		mTechniqueList[i] = new GpuEffectTechnique(this, m_pEffect->GetTechnique(i));
	}

	SetCurrentTechnique("RenderScene");
}

BasicEffect::~BasicEffect()
{
}